
/*

  0x333stalk_client.c
  
     job of client is that generate its keys and connect to server, then follow simple protocol designed.
     client encrypt every msg with public key of server, and server decrypt it with his privaye key.
          
     example use in local, no need parameters for this:
     
     nsn@creature:~/0x333stalk$ ./client
     [*] Generating RSA KEY 2048 BITS E: 65537;
     ...........................................................................+++
     ..............+++
     *** Waiting SERVER BANNER
     *** RECEVIED SERVER BANNER: 0x333stalk_server-0.1

     *** Trying EXCHANGEKEYS
     *** Pubkey RECEVIED (if is incorrect target host will not able decrypt any msg)
     *** KEYS EXCHANGED!
     *** Waiting server while choose a nickname
     *** Insert your nickname (max 25 chars): c0w
     *** Connection Estabelished with nsn, now you are talking with him ***

     any bugs, ideas send mail to nsn@0x333.org
     
  coded by nsn / 0x333 Outsiders Security Labs / www.0x333.org

*/

#include "config.h"


char            * HOST                       = "127.0.0.1"; //can be changed with option -i
int               DEFAULTSERVERPORT          = 0x8235; //can bechanged with option -p

   
void
usage (char *prg)
{

   fprintf (stderr, " [~] Client version to connect to a 0x333stalk server [~]\n");
   fprintf (stderr, " [~] coded by %s of %s %s [~]\n\n", AUTHOR, TEAM, URL);
   fprintf (stderr, " Usage: %s [-i ] [ -p port ] [ -h ]\n\n", prg);
   fprintf (stderr, " \t-i :\t ip of remote server (default: %s)\n", HOST);
   fprintf (stderr, " \t-p :\t port of remote server (default: %d)\n", DEFAULTSERVERPORT);
   fprintf (stderr, " \t-h :\t display this help\n\n");

   exit(EXITCODE);
   
}

int
main (int argc, char *argv[])
{

   RSA           * myclientkey;
   infofriend      server;     
   
   int           * clientsocket = malloc(sizeof(int)),
                   c;
                   
   char            datastring[BITSENC],
                   mynickname[MAXLENNICK];
              
                   
   while (( c = getopt (argc,argv,"p:i:h")) != EOF)
   {
      switch(c)
      {
         case 'i' : HOST = optarg;break;
         case 'p' : DEFAULTSERVERPORT = atoi(optarg);break;
         case 'h' : usage(argv[0]);break;
         default  : usage(argv[0]);
      }    
   }
   

   if ((strcmp(HOST, "")) && (strlen(HOST) <= 30) && (checkPort(MINPORT, MAXPORT, DEFAULTSERVERPORT))) {

      signal(SIGINT, myexit);   //catching interrupts
      
      printf("[*] Generating RSA KEYS %d BITS E: %d;\n", BITSENC, COPRIMO);
      myclientkey = generateKEYS(BITSENC, COPRIMO, NAMEFILEPUBKEY_CLIENT);
         
      if (connection(HOST, DEFAULTSERVERPORT, clientsocket)) {

         printf("*** Waiting SERVER BANNER\n");
         memset(datastring, 0, BITSENC); 
         read(*clientsocket, datastring, BITSENC - 1);
         printf("*** RECEVIED SERVER BANNER: %s\n", datastring);
         
         if (!memcmp(datastring, SERVERBANNER, strlen(SERVERBANNER)-1)) {
         
            /* PROTO STEP 1 */
               
            printf("*** Trying EXCHANGEKEYS\n");
            writesocket(*clientsocket, NORMALTEXT, "EXCHANGEKEYS\n");

            if (exchangeKeys(*clientsocket, &(server.pubkeyfriend), NAMEFILEPUBKEY_CLIENT, NAMETEMPFILEPUBKEY_SERVER))
               printf("*** KEYS EXCHANGED!\n");
            else
               error("Something wrong... while exchanging pubkeys");
               
            printf("*** Waiting server while choose a nickname\n");
            memset(datastring, 0, BITSENC); 
            read(*clientsocket, datastring, BITSENC - 1);               
                            
            /* PROTO STEP 2 */
            
            if (!memcmp(datastring, "TALK OK?", strlen("TALK OK?"))) { 
            
               printf("*** Insert your nickname (max %d chars): ", MAXLENNICK);
               fgets(mynickname, MAXLENNICK, stdin);
               mynickname[strlen(mynickname) - 1] = '\0';
               writesocket(*clientsocket, NORMALTEXT, "TALK OK!\n");

               /* PROTO STEP 3 */

               stalk(*clientsocket, server.pubkeyfriend, myclientkey, mynickname);
               
            }
            else
               error("Protocol mismatch");
            
         }
         else
            error("Recevied a banner not of 0x333stalk application, is impossible continue");
     
      }
      else
         error("Failed Connection Ip %s Port %d", HOST, DEFAULTSERVERPORT);
      
   }
   else
      error("Ip too long or void, or wrong port (have to be between %d-%d)", MINPORT, MAXPORT);

   
  free(clientsocket);
  free(myclientkey);
  remove(NAMEFILEPUBKEY_CLIENT);   
  remove(NAMETEMPFILEPUBKEY_SERVER);
   
}

/*
  EOF
 */ 
