
/*

  0x333stalk_config.h / contains configuration values and functions for client and server.
  
  coded by nsn / 0x333 Outsiders Security Labs / www.0x333.org
  
*/

#include                               <openssl/rsa.h>
#include                               <openssl/pem.h>
#include                               <openssl/err.h>
#include                               <stdlib.h>
#include                               <unistd.h>
#include                               <sys/ioctl.h>
#include                               <sys/socket.h>
#include                               <sys/types.h>
#include                               <netinet/in.h>
#include                               <netdb.h>
#include                               <ncurses.h>
#include                               <signal.h>
#include                               <time.h>

#define AUTHOR                         "nsn"
#define MAIL                           "nsn@0x333.org"
#define TEAM                           "0x333 Outsiders Security Labs"
#define URL                            "www.0x333.org"
#define VERSION                        "0.1"

#define SERVERBANNER                   "0x333stalk_server-0.1"
#define MINPORT                        0x0001
#define MAXPORT                        0xFFFF

#define NAMEFILEPUBKEY_SERVER          "pubkey_server.rsa"
#define NAMEFILEPUBKEY_CLIENT          "pubkey_client.rsa"
#define NAMETEMPFILEPUBKEY_SERVER      "temppubkey_server.rsa"
#define NAMETEMPFILEPUBKEY_CLIENT      "temppubkey_client.rsa"
#define BITSENC                        2048
#define COPRIMO                        65537ul 

#define MAXLENNICK                     25
#define MAXSTRING                      256
#define NORMALTEXT                     0

#define CLOSESOCKET                    1
#define ABORTALL                       2
#define EXITCODE                       -3

//ncurses already use constants FALSE and TRUE then we changed with ISFALSE and ISTRUE

typedef enum    {ISFALSE,ISTRUE}    BOOLEAN;

typedef struct {
   RSA                   * pubkeyfriend;
   struct sockaddr_in      rem_addr;
   int                     socketfriend;
   int                     len_sockaddr;
}infofriend;

typedef struct {
	WINDOW	             * win;
	int	                   nlines;
	int	                   ncols;
	int	                   beginy;
	int	                   beginx;
}xwin;	

extern    xwin             editwinline;
extern    xwin             editwin;
extern    xwin             mywin;
extern    xwin             centerlinewin;
extern    xwin             hiswin;

extern    int              MAXROWS;
extern    int              MAXCOLS;

#ifdef SERVER
   extern    BOOLEAN       FRIENDLOGGED;
#endif
   
extern    int              DEFAULTSERVERPORT;
extern    char           * HOST;

extern    void             myexit             (int );
extern    void             error              (const char *, ...);

extern    void             init_display       ();
extern    void             cleanwin           ();
extern    void             adjust             (int);

extern    char           * getDateTime        (char *);

extern    RSA            * generateKEYS       (int, unsigned long , char *);
extern    BOOLEAN          exchangeKeys       (int , RSA **, char *, char *);
extern    void             genrsa_callback    (int , int , void *);
extern    void             stalk              (int , RSA *, RSA *, char *);

extern    BOOLEAN          checkPort          (const int, const int, int );
extern    BOOLEAN          connection         (char *, int , int *);
extern    BOOLEAN          listening          (int *, int , int ); 
extern    void             writesocket        (int , int , const char *, ...);

/*
  EOF
 */
